PRO fake_atm,r_fake,density_fake,pressure_fake,gamma_fake,gravity_fake,sound_speed_fake,temp_fake

data=DBLARR(25,2481)
openr,1,'solar_S'
readf,1,data
close,1
data = reverse(data,2)
Rsol=6.959894677E+10
Msol=1.989000000E+33
G=6.6732d-8
r_start = 0.98
masse = EXP(data[1,*])*Msol
gravity=G*masse/(data[0,*])^2.0d0
sound_speed = (data[9,*]*data[3,*]/data[4,*])^0.5

den = data[4,*]
pre = data[3,*]
temp = data[2,*]
r = data[0,*]/Rsol
x = WHERE(ABS(r-r_start) EQ MIN(ABS(r-r_start)))
y = WHERE(ABS(r-1.) EQ MIN(ABS(r-1.0)))
;z = WHERE(ABS(r-0.992) EQ MIN(ABS(r-0.992)))

s = r[x:2480]
d = den[x:2480]
p = pre[x:2480]
t = temp[x:2480]
gra0 = gravity[x:2480] 
gam = data[9,x:2480]
;H_scale = ;68.*10.^5/Rsol



z = WHERE(ABS(s-0.9998) EQ MIN(ABS(s-0.9998)))
ffff = size(s) 
ma = ffff(1)-1
dn = DBLARR(ma[0]+1,1)
pn = DBLARR(ma[0]+1,1)
tn = DBLARR(ma[0]+1,1)


ma1 = WHERE(ABS(s-0.9989) EQ MIN(ABS(s-0.9989)))
ma2 = WHERE(ABS(s-0.9999) EQ MIN(ABS(s-0.9999)))
ma1 = z
m  = 1.1751/(gam[0]-1.)
cutoff = 00.*10.^5./Rsol

gg = ALOG(d/d[0])/ALOG((1.-s)/(1.-s[0]))
gg2 = ALOG(p/p[0])/ALOG((1.-s)/(1.-s[0]))

gg[0] = gg[1]
gg[*] = gg[5] 
cutoff = DBLARR(ma1[0]+1) 
FOR J = 0,ma1[0] DO BEGIN
  cutoff[j] = 10.^(5.)/Rsol *(704. - 805.*((s[J] - s[0])/(s[z[0]]-s[0]))^2.1 )
  dn[J] = d[0]*((1.-cutoff[J]-s[J])/(1.-cutoff[0] -s[0]))^gg[J]
  pn[J] = p[0]*((1.-cutoff[J]-s[J])/(1.-cutoff[0]-s[0]))^(gg[J]+1.)
ENDFOR 

  tn[0:z[0]] = (1.-cutoff-s[0:z[0]])
  tn[0:z[0]] = tn[0:z[0]] *t[0]/tn[0]

temp_g = -1./(dn[0:z[0]]*Rsol) * deriv(s[0:z[0]],pn[0:z[0]])

H_scale = pn[z[0]]/(temp_g[z[0]]*dn[z[0]]*Rsol)
cutoff2 = 0.00
std = dn[z[0]]
dn[z[0]:ma[0]] = std[0]*exp((1.+cutoff2 - s[z[0]:ma[0]])/H_scale[0])*exp(-(1.+cutoff2-s[z[0]])/H_scale[0])
std = pn[z[0]]
pn[z[0]:ma] = std[0]*exp((1. - s[z[0]:ma[0]])/H_scale[0])*exp(-(1.-s[z[0]])/H_scale[0])
tn[z[0]+1:ma[0]] = tn[z[0]]

gr = -1./(dn*Rsol) * deriv(s,pn) 

hd = -1./deriv(s,ALOG(dn))
hp = -1./deriv(s,ALOG(pn))
hd0 = -1./deriv(s,ALOG(d))
hp0 = -1./deriv(s,ALOG(p))


c0 = (gam *p/d)^0.5
c_off0 = 1./(2.*!dPI) * c0/(2.*hp0*Rsol) *(1-2.*deriv(s,hp0))^0.5
gam0 = gam 
ga = DBLARR(ma[0]+1)
FOR J=0,ma[0] DO BEGIN
  ga[J] = MAX([1.01 + 1./gg[J],gam[J]])
ENDFOR
gam=ga[*]

c = (gam *pn/dn)^0.5
c_off = 1./(2.*!dPI) * c/(2.*hp*Rsol) *(1-2.*deriv(s,hp))^0.5

den[x[0]:2480] = dn
pre[x[0]:2480] = pn
hdd = -1./deriv(r,ALOG(pre))
c_f = (data[9,*] *pre/den)^0.5
c_f[x[0]:2480] = c 
c_off_f = 1./(2.*!dPI) * c_f/(2.*hdd*Rsol) *(1.-2.*deriv(r,hdd))^0.5

gravity[x:2480] = gr 
pre[x:2480] = pn
den[x:2480] = dn
temp[x[0]+z[0]:2480] = tn[z[0]]
gamma_n = DBLARR(2481)
gamma_n[0:x] = data[9,0:x] 
gamma_n[x[0]:2480] = gam
sound_speed[x[0]:2480] = c

n2 = gr/Rsol*(1./gam *deriv(s,ALOG(pn)) - deriv(s,ALOG(dn)))

drnew = (r[2480] - r[2479])
rnewt = DBLARR(500)
gam_new = DBLARR(500)
pre_new = DBLARR(500)
den_new = DBLARR(500)
temp_new = DBLARR(500)
gravity_new = DBLARR(500)
ss_new = DBLARR(500)

rnewt[*] = drnew* (DINDGEN(500) + 1.0) + r[2480]
gam_new[*] =  gamma_n[2480]
pre_new[*] = pre[2480]*exp((1. - rnewt[*])/H_scale[0])*exp(-(1.- rnewt[0])/H_scale[0])
den_new[*] = den[2480]*pre_new[*]/pre[2480]
temp_new[*] = temp[2480]
ss_new[*] = sound_speed[2480]
gravity_new[*] = gravity[2480]

density_fake = [den[*],den_new]
pressure_fake = [pre[*],pre_new]
gamma_fake = [gamma_n[*],gam_new]
sound_speed_fake = [sound_speed[*], ss_new]
gravity_fake = [gravity[*],gravity_new]
temp_fake = [temp[*],temp_new]
r_fake = [r[*],rnewt]
;read, pause

END



